// $Id: tideDialog.h 4046 2011-09-07 21:43:34Z flaterco $

/*****************************************************************************\

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\*****************************************************************************/


#ifndef TIDEDIALOG_H
#define TIDEDIALOG_H

/* RWL the following ifdef removes a templates error when compiling with MSVC (Known bug) */

#ifdef WIN32
#include <math.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <qapplication.h>
#include <qevent.h>
#include <qpainter.h>
#include <q3toolbar.h>
#include <qtoolbutton.h>
#include <q3popupmenu.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <q3hbox.h>
#include <q3vbox.h>
#include <qmessagebox.h>
#include <qtooltip.h>
#include <qrect.h>
#include <qpoint.h>
#include <qcolordialog.h>
#include <q3filedialog.h>
#include <qcursor.h>
#include <qimage.h>
#include <q3strlist.h>
#include <q3intdict.h>
#include <q3whatsthis.h>
#include <qaction.h>
#include <q3mainwindow.h>
#include <q3rangecontrol.h>
#include <qpen.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qstring.h>
#include <q3pointarray.h>
#include <q3tabdialog.h>
#include <qcombobox.h>
#include <q3textedit.h>
#include <q3table.h>
#include <q3header.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <q3listbox.h>
#include <qpushbutton.h>
#include <qstringlist.h>
#include <qinputdialog.h>
#include <qprinter.h>
#include <q3paintdevicemetrics.h>
#include <q3simplerichtext.h>

#include <tcd.h>
#include "tideEditor.h"

#define ConstituentNameLen 15
typedef struct
{
    int        num;
    char       name[ConstituentNameLen];
} CONSTITUENT;


class TideDialog:public Q3TabDialog
{
    Q_OBJECT 


  public:

    TideDialog (QWidget *parent, const char *name, TIDE_RECORD lrec, NV_BOOL ro, TideEditor *te);
    ~TideDialog ();


  protected:

    DB_HEADER_PUBLIC db;
    TIDE_RECORD rec, inf_rec;
    TideEditor *tideEditor;

    NV_BOOL readonly;


    Q3TabDialog *tideDialog;
    Q3TextEdit *comments, *notes, *xfields;
    QLineEdit *name, *source, *lat, *lon, *datum_offset, *zone_offset, *months,
      *min_time_add, *min_level_add, *min_level_mult, 
      *min_direction, *max_time_add, *max_level_add, *max_level_mult, 
      *max_direction, *flood_begins, *ebb_begins, 
      *expiration_date, *ldos, *station_id_context, *station_id,
      *date_imported, *confidence;
    QComboBox *tzfile, *country, *restriction,
      *level_units, *direction_units, *legalese, *datum;
    Q3ListBox *subList;
    Q3Table *constituents;

    int *sub_station;

    CONSTITUENT *cnst;


    void generalTab ();
    void constituentsTab ();
    void offsetsTab ();


  protected slots:

    void slotUpdateStation ();
    void slotCancelStation ();
    void slotDeleteStation ();
    void slotPrintStation ();
    void slotChangeRefStation ();

  private:
};

#endif
