// $Id: tideList.h 4057 2011-09-15 01:12:24Z flaterco $

/*****************************************************************************\

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\*****************************************************************************/


#ifndef TIDELIST_H
#define TIDELIST_H

/* RWL the following ifdef removes a templates error when compiling with MSVC (Known bug) */

#ifdef WIN32
#include <math.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <qapplication.h>
#include <qevent.h>
#include <qpainter.h>
#include <q3toolbar.h>
#include <qtoolbutton.h>
#include <q3popupmenu.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <q3hbox.h>
#include <q3vbox.h>
#include <qmessagebox.h>
#include <qtooltip.h>
#include <qrect.h>
#include <qpoint.h>
#include <qcolordialog.h>
#include <q3filedialog.h>
#include <qcursor.h>
#include <qimage.h>
#include <q3strlist.h>
#include <q3intdict.h>
#include <q3whatsthis.h>
#include <qaction.h>
#include <q3mainwindow.h>
#include <q3rangecontrol.h>
#include <qpen.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qstring.h>
#include <q3pointarray.h>
#include <q3tabdialog.h>
#include <qcombobox.h>
#include <q3textedit.h>
#include <q3table.h>
#include <q3header.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <q3listbox.h>
#include <qtabwidget.h> 

#include "tideEditor.h"

#include <vector>

#define STATIONS_PER_PAGE   2000

class TideList:public Q3TabDialog
{
    Q_OBJECT 


  public:

  TideList (QWidget *parent, const char *name, NV_BOOL ro);
    ~TideList ();


    void updateTideList ();


  protected:

    NV_BOOL readonly;

    DB_HEADER_PUBLIC db;
    TIDE_RECORD rec;

    QTabWidget *tideList;

    TideEditor *tideEditor;

    Q3ListBox **stationList;

    int numtabs, page, lastrec;
    std::vector<bool> page_displayed;


  protected slots:

    void slotCurrentChanged ();
    void slotSelected ();
    void slotHighlighted ();


  private:
};

#endif
